#include <winsock.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define VERSION 0x0101
#define PRINCIPAL HIBYTE(VERSION)
#define RELEASE   LOBYTE(VERSION)
#define NUM_MIN_SOCKETS 1

#define PUERTO 12345

int main(void)
{
	WSADATA wsaData;
	SOCKET  sock;

	char Buffer[128];
	char *server_name= "localhost";
	int retval;
	int loopcount=-1;
	unsigned int addr;
	struct sockaddr_in server;
	struct hostent *hp;

	
	if (WSAStartup(VERSION,&wsaData) == SOCKET_ERROR)
	{
		fprintf(stderr,"fallo en WSAStartup con error %d\n",WSAGetLastError());
		WSACleanup();
		return -1;
	}
	
	//
	// Averiguar si debemos llamar a gethostbyname() o gethostbyaddr()
	
	if (isalpha(server_name[0]))
	{
		hp = gethostbyname(server_name);
	}
	else
	{
		addr = inet_addr(server_name);
		hp = gethostbyaddr((char *)&addr,4,AF_INET);
	}
	if (hp == NULL )
	{
		fprintf(stderr,"No se puede resolver el nombre del servidor [%s]: Error %d\n",
			server_name,WSAGetLastError());
		WSACleanup();
		exit(1);
	}
	
	//
	// Copiar los datos del servidor a la estructura sockaddr_in
	//
	memset(&server,0,sizeof(struct sockaddr_in));
	memcpy(&(server.sin_addr),hp->h_addr,hp->h_length);
	server.sin_family = hp->h_addrtype;
	server.sin_port = htons(PUERTO);
	
	// crear el socket
	sock = socket(AF_INET,SOCK_DGRAM,0);
	if (sock <0 )
	{
		fprintf(stderr,"fallo al crear el socket con error %d\n",WSAGetLastError());
		WSACleanup();
		return -1;
	}
	
	printf("conectado con el servidor: %s\n",hp->h_name);
	if (connect(sock,(struct sockaddr*)&server,sizeof(server))== SOCKET_ERROR)
	{
		fprintf(stderr,"connect() failed: %d\n",WSAGetLastError());
		WSACleanup();
		return -1;
	}
	
	// Preparar una cadena para enviar
	//
	loopcount =0;
	while(1)
	{
		gets(Buffer);
		if (strlen(Buffer)>0)
		{
			retval = send(sock,Buffer,strlen(Buffer),0);
			if (retval == SOCKET_ERROR)
			{
				fprintf(stderr,"fallo en send() con error %d\n",WSAGetLastError());
				WSACleanup();
				return -1;
			}
			printf("Enviado msg [%s]\n",Buffer);

			// Esperar el eco
			retval = recv(sock,Buffer,sizeof (Buffer),0 );
			if (retval == SOCKET_ERROR)
			{
				fprintf(stderr,"fallo en recv() con error %d\n",WSAGetLastError());
				closesocket(sock);
				WSACleanup();
				return -1;
			}
			if (retval == 0)
			{
				printf("El servidor cerr la conexin\n");
				closesocket(sock);
				WSACleanup();
				return -1;
			}
			printf("Recibidos %d bytes, msg [%s] del servidor\n",retval,Buffer);
			loopcount++;
		}
		else
		{
			loopcount=11;
		}
		if (loopcount>=10)
			break;
	}
	closesocket(sock);
	WSACleanup();
	return 0;
}
